#!/bin/sh
#FUNCTIONS FOR HACKYREMASTER


getloopy() {

	NOTENOUGHLOOPS="false"
	CONTINUE="true"
	INCRIMENT=0

	while [ $CONTINUE = "true" ]; do

		losetup-FULL /dev/loop$INCRIMENT > /dev/null 2>&1
		ERRORCODE=$?

		case $ERRORCODE in
			0)
				INCRIMENT=`expr $INCRIMENT + 1`
			;;
			1)
				CONTINUE="false"
				echo "Already availiable loop device..."
			;;
			2)
				echo "Creating new loop device /dev/loop$INCRIMENT..."
				mknod -m660 /dev/loop$INCRIMENT b 7 $INCRIMENT
				CONTINUE="false"
				echo "Successfully made new loop device /dev/loop$INCRIMENT..."
			;; esac

		if [ $INCRIMENT = 8 ]; then
			CONTINUE="false"
			NOTENOUGHLOOPS="true"
			echo "NO loop devices availiable and one can't be created..."
		fi

	done

	} #END GETLOOPY


loopymount() {

	LERRORCODE=1
	while [ $LERRORCODE = 1 ]; do
		echo "Searching for availible loop device..."
		getloopy
		if [ $NOTENOUGHLOOPS = "true" ]; then
			Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --yesno "A loop device was not found.  You must have all eight devices in use.  Please unmount one to continue.  Hit 'Yes' when you're ready to continue, or 'No' to abort." 8 50
			ANSWER=$?
			if [ $ANSWER = 1 ]; then
				echo "ABORTING..."
				LERRORCODE=2
			else
				echo "We'll try again, then."
				LERRORCODE=1
			fi
		else
			LERRORCODE=0
		fi
	done

	case $LERRORCODE in
		0)
			echo "Okay, there is one availiable."
		;;
		1)
			echo "Error 1.  Thish error shouldn't have gotten through."
			echo "Something funky is going on if you are seeing this.  You"
			echo "should notify Pizzasgood so he can figure out where the"
			echo "monkey wrech is..."
			exit 1
		;;
		2)
			echo "Error 255 - ABORTED"
			exit 255
		;; esac

	} #END LOOPYMOUNT


setupenviron() {

	#This asks and verifies the directory to use.
	REMASTER="remaster"
	DERRORCODE=1
	while [ $DERRORCODE = 1 ]; do
		CERRORCODE=1
		while [ $CERRORCODE = 1 ]; do
			DIRTOUSE=`Xdialog --title "HackyRemaster" --stdout --wrap --backtitle "Welcome to HackyRemaster.  This portion of the script will setup the environment. It will need a directory to use.  It should be on a harddrive because it will probably need approximately 400 megabytes.  A directory will be created there named 'remaster.'" --no-cancel --dselect / 40 60`
			CERRORCODE=$?
			if [ $CERRORCODE = 255 ]; then echo "ABORTED"; exit 255; fi
		done
		Xdialog --title "HackyRemaster" --stdout --wrap --yesno "Are you absolutely positive you wish to use $DIRTOUSE? The directory $DIRTOUSE$REMASTER will be created, and it will probably need approximately 400 megabytes.  Choose no to re-choose." 10 60
		DERRORCODE=$?
		if [ $DERRORCODE = 255 ]; then echo "ABORTED"; exit 255; fi
	done

	#Sets up the directories.
	cd $DIRTOUSE
	echo "making directory $DIRTOUSE$REMASTER"
	mkdir $REMASTER
	cd $REMASTER
	echo "making directory $DIRTOUSE$REMASTER/iso"
	mkdir iso

	#Mounts the base-filesystem.
	DERRORCODE=1
	while [ ! $DERRORCODE = 0 ]; do
		CERRORCODE=1
		while [ $CERRORCODE = 1 ]; do
			MEDIA=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --radiolist "HackyRemaster needs a filesystem from which to work.  You may either use a CD or an ISO file.  Choose one:" 12 50 2 "CD" "Get filesystem from CD" selected "ISO" "Get filesystem from ISO" unselected`
			CERRORCODE=$?
			if [ $CERRORCODE = 255 ]; then echo "ABORTED"; exit 255; fi
		done
		case $MEDIA in
			CD)
				FERRORCODE=1
				while [ $FERRORCODE = 1 ]; do
					Xdialog --title "HackyRemaster" --wrap --stdout --msgbox "Please insert the cd now." 0 0
					DERRORCODE=$?
					if [ $DERRORCODE = 0 ]; then
						killall gcombust > /dev/null 2>&1 #just in case.
						echo "mounting cd...."
						mount -t iso9660 /dev/cdrom /mnt/cdrom
						if [ ! $? -eq 0 ];then
							echo "ERROR: It isn't mounting.  Make sure the correct disk is in the drive."
							Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "ERROR: It isn't mounting.  Make sure the correct disk is in the drive." 0 0 0 0
						else FERRORCODE=0
						fi
					else FERRORCODE=0
					fi
				done
			;;
			ISO)
				FERRORCODE=1
				while [ $FERRORCODE = 1 ]; do
					ISOLOCATION=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --backtitle "Okay, find the ISO to use:" --fselect /root 0 0`
					DERRORCODE=$?
					if [ $DERRORCODE = 0 ]; then
						loopymount
						mount -t iso9660 "$ISOLOCATION" /mnt/cdrom -o loop
						if [ ! $? -eq 0 ];then
							echo "ERROR: It isn't mounting.  Check the path to the ISO file."
							Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "ERROR: It isn't mounting.  Check the path to the ISO file." 0 0
						else FERRORCODE=0
						fi
					else FERRORCODE=0
					fi
				done
			;; esac

	done

	#Copy files from cd/iso to $DIRTOUSE$REMASTER/iso/
	echo "copying files from $MEDIA (/mnt/cdrom/) to $DIRTOUSE$REMASTER/iso/...."
	cp -r /mnt/cdrom/* iso/

	#Unmount the cd/iso
	echo "unmounting $MEDIA (/mnt/cdrom)..."
	rox -D "/mnt/cdrom" > /dev/null 2>&1
	umount /mnt/cdrom

	#If it's a cd, then eject it.
	if [ $MEDIA = "CD" ]; then
		#probably an awful hack, but want eject* to work...
		mount > /etc/mtab
		/usr/bin/eject /dev/cdrom
		Xdialog --title "HackyRemaster" --wrap --stdout --msgbox "You may now remove the CD.  Press 'Ok' when done." 0 0
	fi

	#Get the size for the image
	FILESYSTEMSIZE=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --inputbox "Next we will make a filesystem image to store the new Puppy's filesytem in while we work on it.  Please enter the size you wish to use.  256 megabytes is reccommended, because Puppy gets large once extracted, and you need to leave room for additional stuff.  If you're making a mega-Puppy, you'll need even more space.  The size should be in megabytes.  Enter it here:" 14 60 256`
	CERRORCODE=$?
	if [ $CERRORCODE = 255 ]; then echo "ABORTED"; exit 255; fi

(	# <---This is so we can pop up a "busy" message

	#Make the image
	echo "creating an image of size $FILESYSTEMSIZE...."
	dd if=/dev/zero of=image bs=1M count=$FILESYSTEMSIZE > /dev/null 2>&1
	sync
	echo "creating ext2 filesystem on the image..."
	mke2fs -m 0 -b 1024 -qF image

	#Mount the image to $HACKYROOT
	loopymount
	echo "creating directory $HACKYROOT..."
	mkdir "$HACKYROOT"
	echo "mounting image to$HACKYROOT..."
	mount image "$HACKYROOT" -t ext2 -o loop,rw

	#Decompress and mount image.gz
	cd iso
	echo "decompressing image.gz..."
	gunzip image.gz -d
	loopymount
	echo "creating directory /mnt/tmpimage..."
	mkdir /mnt/tmpimage
	echo "mounting gunzipped image.gz to /mnt/tmpimage..."
	mount image /mnt/tmpimage -t ext2 -o loop,ro

	#Copy the filesystem from image.gz to $HACKYROOT/filesystem
	echo "copying the filesystem from image.gz to $HACKYROOT/filesystem"
	cp -a /mnt/tmpimage "$HACKYROOT/filesystem"

	#Unmount and delete the extracted image.gz
	echo "unmounting image.gz..."
	umount /mnt/tmpimage
	echo "removing old image.gz..."
	rm image

	#Mount usr_cram.fs and copy the filesystem to $HACKYROOT/filesystem/usr
	loopymount
	echo "mounting usr_cram.fs to /mnt/tmpimage..."
	mount usr_cram.fs /mnt/tmpimage -t squashfs -o loop,ro
	echo "copying the filesystem to $HACKYROOT/filesystem/usr..."
	cp -a /mnt/tmpimage "$HACKYROOT/filesystem/usr"

	#Unmount and delete usr_cram.fs
	echo "unmounting /mnt/tmpimage..."
	umount /mnt/tmpimage
	echo "deleting /mnt/tmpimage..."
	rm -r /mnt/tmpimage
	echo "deleting the old usr_cram.fs..."
	rm usr_cram.fs

	#Make files storing the paths to important directories...
	cd $APPLOCATION
	echo "creating files storing the paths to important directories..."
	echo "$DIRTOUSE$REMASTER" > ./remasterpath
	echo "$DIRTOUSE$REMASTER/iso" > ./isopath

) | Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --infobox "Setting up.  This window will close itself when finished. Please stand by....." 7 40 0

	#Finished with setting up the environment
	rox $HACKYROOT/filesystem
	Xdialog --title "HackyRemaster" --wrap --stdout --beep --msgbox "The environment is now set up.  $HACKYROOT/filesystem is / of the new Puppy's filesystem. $HACKYROOT is already mounted.  $DIRTOUSE$REMASTER/iso is the directory in which the iso components will be stored.  $DIRTOUSE$REMASTER is the directory that the image and iso are/will be." 12 50
	echo "DONE."

	} #END SETUPENVIRON


readyenviron() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Mount the image on $HACKYROOT
	loopymount
	echo "mounting $ISOPATH/../image to $HACKYROOT..."
	mkdir "$HACKYROOT"
	mount $ISOPATH/../image "$HACKYROOT" -t ext2 -o loop,rw
	rox $HACKYROOT/filesystem
	Xdialog --title "HackyRemaster" --wrap --stdout --msgbox "The image has been mounted to $HACKYROOT.  You may now edit it." 6 50
	echo "DONE."

	} #END READYENVIRON


recompressusr() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	cd "$HACKYROOT/filesystem"

	#Compress /usr
	echo "Compressing /usr...."
	if [ -e "$ISOPATH/usr_cram.fs" ]; then rm "$ISOPATH/usr_cram.fs"; fi
	mksquashfs usr "$ISOPATH/usr_cram.fs" | Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --infobox "Compressing /usr. This window will close itself when finished.  Please stand by...." 0 0 0

	#Size of usr_cram.fs needed by rc.sysinit to verify correct version of usr_cram.fs...
	SIZEUSRCRAM="`ls -l "$ISOPATH/usr_cram.fs" | tr -s ' ' | cut -f 5 -d ' '`"
	echo -n "$SIZEUSRCRAM" > root0/.etc/sizeusrcram

	#Finished
	echo "DONE."
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --beep --msgbox "Done.  /usr compressed into /usr_cram.fs." 8 40

	} #END RECOMPRESSUSR


makerootimage() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Get usr out of the way so we can simplify things...
	cd "$HACKYROOT/filesystem"
	echo "moving usr to ../usr_moved to keep it out of the way..."
	mv usr ../usr_moved

	#Get the size of the image contents (keep in mind it is neglecting usr)
	IMAGEUSED=`du -ks "$HACKYROOT/filesystem" | cut -f 1`

	#Free space.  Squashfs management uses most of that $IMAGEFREE.
	IMAGEFREE=448

	#Calculate the correct total size.
	#Space gets wasted, so we make it extra big, by roughly 4 percent, plus thirteen k.
	IMAGEWANTSIZE=`expr $IMAGEUSED + $IMAGEFREE`
	IMAGESIZE=`expr $IMAGEWANTSIZE \* 26 \/ 25 \+ 13`
	#Display a notice if the size is more than the default kernal accepted size.
	if [ $IMAGESIZE -gt 12288 ];then
		echo "<< The ramdisk needs to be set to $IMAGESIZE >>"
		Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --beep --msgbox "The kernal is compiled to use a ramdisk of 12288 Kbytes.  However, we need a ramdisk size of $IMAGESIZE Kbytes.  A bit later, you will be allowed to edit isolinux.cfg.  The script will then automatically input the correct parameters.  If you opt out of the auto-config, keep in mind that you'll need to add the correct size manually." 11 60
	else
		IMAGESIZE=12288 #to match default ramdisk size of kernel.
	fi

	#Add the correct size to root0/.etc/ramdiskfssize
	#...note, /sbin/init will change this at bootup.
	echo -n "$IMAGESIZE" > root0/.etc/ramdiskfssize

	#Make and format the image
	echo "creating filesystem image with size $IMAGESIZE..."
	sync
	dd if=/dev/zero of=$ISOPATH/image bs=1k count=$IMAGESIZE > /dev/null 2>&1
	sync
	echo "formatting image to ext2..."
	mke2fs -m 0 -b 1024 -qF $ISOPATH/image
	sync

	#Mount the image
	loopymount
	echo "mounting $ISOPATH/image to $HACKYIMAGE..."
	mkdir "$HACKYIMAGE"
	mount $ISOPATH/image "$HACKYIMAGE" -t ext2 -o loop,rw

	#Copy the data to the image
	sync
	echo "copying filesystem to the new filesystem..."
	cp * "$HACKYIMAGE" -a | Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --infobox "Copying the in $HACKYROOT/filesystem/* to the image we just made. This window will close itself when finished.  Please stand by...." 7 60 0
	echo "done..."
	sync

	#Unmount $HACKYIMAGE
	echo "unmounting $ISOPATH/image..."
	rox -D "$HACKYIMAGE" > /dev/null 2>&1
	umount "$HACKYIMAGE"
	rm -r "$HACKYIMAGE"

	#Compress image into image.gz
	echo "compressing image into image.gz..."
	gzip -f9 $ISOPATH/image | Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --infobox "Compressing image into image.gz. This window will close itself when finished.  Please stand by...." 7 60 0

	#Return usr to its rightful place
	echo "returning usr to its rightful place..."
	mv ../usr_moved usr
	sync

	#Finished
	echo "DONE."
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --beep --msgbox "Done.  image compressed into image.gz." 8 40

	} #END MAKEROOTIMAGE


editisolinuxcfg() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Get the ramdisk size so we can create isolinux.cfg correctly
	RAMDSKSIZE="`cat $HACKYROOT/filesystem/root0/.etc/ramdiskfssize`"

	#Prompt for permission to generate isolinux.cfg
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "You now have the opportunity to edit isolinux.cfg, the file that determines the boot menu when Puppy is run as a live-cd.  This script can generate one to your specifications, or you can do it manually.  You also have the option of first letting the script create it, then editing it after.  Keep in mind that if this script doesn't automatically generate it, the correct image size will not be automatically added." 15 60 --yesno "Allow HackyRemaster to generate isolinux.cfg?" 7 60
	ALLOW=$?

	case $ALLOW in
		255)
			echo "ABORTED"
			exit 255
		;;
		0)
			PUPFILE=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --inputbox "Enter the name for the pupfile.  If unsure, just use pup001:" 8 60 pup001`
			if [ ! $? = 0 ];then echo "ABORTED"; exit 255; fi
			PUPFILESIZE=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --inputbox "Enter the size for the pupfile.  If unsure, just use 262144:" 8 60 262144`
			if [ ! $? = 0 ];then echo "ABORTED"; exit 255; fi
			TIMEOUT=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --inputbox "Enter the length in tenths of a second for the timout.  If unsure, just use 100:" 8 60 100`
			if [ ! $? = 0 ];then echo "ABORTED"; exit 255; fi
			DEFAULTOPTION=`Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --radiolist "Enter the default boot option.\nIf unsure, just use 1" 23 30 7 "0" "Harddrive Boot" unselected "1" "Normal" selected "2" "Normal + ACPI" unselected "3" "Choose Pupfile" unselected "4" "No Pupfile" unselected "5" "Multisession" unselected "6" "Wakeusb" unselected`
			if [ ! $? = 0 ];then echo "ABORTED"; exit 255; fi
			#Edit isolinux.cfg
			echo "default $DEFAULTOPTION
			DISPLAY BOOT.MSG
			prompt 1
			label 0
			 localboot 0x80
			label 1
			 kernel vmlinuz
			 append root=/dev/ram0 initrd=image.gz ramdisk_size=$RAMDSKSIZE acpi=off  PFILE=$PUPFILE-none-$PUPFILESIZE
			label 2
			 kernel vmlinuz
			 append root=/dev/ram0 initrd=image.gz ramdisk_size=$RAMDSKSIZE acpi=on  PFILE=$PUPFILE-none-$PUPFILESIZE
			label 3
			 kernel vmlinuz
			 append root=/dev/ram0 initrd=image.gz ramdisk_size=$RAMDSKSIZE acpi=off  PFILE=ask
			label 4
			 kernel vmlinuz
			 append root=/dev/ram0 initrd=image.gz ramdisk_size=$RAMDSKSIZE acpi=off  PFILE=no
			label 5
			 kernel vmlinuz
			 append root=/dev/ram0 initrd=image.gz ramdisk_size=$RAMDSKSIZE  PFILE=cd
			label 6
			 kernel memdisk
			 append initrd=wakeusb.img ramdisk_size=$RAMDSKSIZE
			timeout $TIMEOUT
			" > $ISOPATH/isolinux.cfg
		;; esac

	#Ask if they want to manually edit isolinux.cfg
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --yesno "Do you wish for HackyRemaster to open isolinux.cfg in the default text editor so you can manually edit it?" 7 60
	ALLOW=$?
	if [ $ALLOW = 0 ]; then
		defaulttexteditor $ISOPATH/isolinux.cfg
	fi

	#Finished
	echo "DONE."
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "Done.  If you need to come back for more manual editing, just run it and choose 'No' when asked to have it generated, then 'Yes' for opening it in a texteditor.  Or you can let it regenerate it if it gets screwed up somehow." 10 60

	} #END EDITISOLINUXCFG


makeintoiso() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Make it an ISO file
	echo "forming $REMASTERPATH/puppy.iso out of $ISOPATH/..."
	mkisofs -o $ISOPATH/../puppy.iso -b isolinux.bin -c boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table $ISOPATH/ | Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --infobox "Making ISO. This window will close itself when finished.  Please stand by...." 7 60 0
	sync

	#Finished
	echo "DONE."
	rox "$REMASTERPATH/"
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "Done.  The ISO is at $REMASTERPATH/puppy.iso  Now you can put in a cdr, cdrw, or dvd and click the 'Burn Iso' button if you want to burn it to a disk.  Otherwise you can just take that iso and do whatever you want." 10 60

	} #END MAKEINTOISO


burnbabyburn() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	###burniso2cd2-by-Barry-Kauler###
	#!/bin/sh
	#simple script to burn an iso file to cd, using cdrecord.
	echo "running a tweaked burniso2cd script..."

	while [ ! -f /etc/cdburnerdevice ];do
	 xmessage -bg "#ff8080" -center -name "burniso2cd" -title "Burniso2cd: No CD burner" -buttons "CD_Wizard:10,EXIT:11" "A problem...
	You have not yet run the Puppy CD/DVD drive Wizard, to choose
	which CD/DVD drive will be the burner drive.
	I know that it seems somewhat academic if your PC only has one
	CD/DVD drive, but you have to do it.
	Click \"CD_Wizard\" button now to run the Wizard, then click on
	\"Choose burner\" then click on \"EXIT\", which will bring you back
	to this script.

	Click \"CD_Wizard\" button to run CD/DVD Wizard..."
	 case $? in
	  10)
	   /usr/sbin/cdburner-wizard
	   ;;
	  *)
	   exit
	   ;;
	 esac
	done

	if [ "`cat /etc/scsiemul 2> /dev/null`" = "on"  ];then
	 xmessage -bg "#ff8080" -center -name "burniso2cd" -title "Burniso2cd: ERROR" -buttons "EXIT:11" "This script is setup to do ATAPI CD burning, but you have
	SCSI-emulation turned on. Therefore this script cannot burn
	the iso file to CD and you will have to do it in a CD-burner
	program such as Gcombust or Xcdroast.
	So, no choice now but to exit script."
	 exit
	fi


	BURNERDRIVE="/dev/`cat /etc/cdburnerdevice`" #set by CD/DVD Wizard.
	CDR="$BURNERDRIVE" #not recommended, but works.
	CDDESCR="`probedisk | grep "$CDR" | cut -f 3 -d '|'`"

	while [ ! "`mount | grep "$CDR"`" = "" ];do
	 xmessage -bg "#ff8080" -center -name "burniso2cd" -title "Burniso2cd: ERROR" "The $CDR CD/DVD drive, described as:
	 $CDDESCR
	is currently mounted.
	Use MUT to unmount it.

	Please unmount CD drive, then click OK button..."
	done

	xmessage -bg "#ffc0c0" -center -name "burniso2cd" -title "Burniso2cd: Multisession" -buttons "NORMAL-CD:10,NORMAL-DVD:13,MULTI-CD:11,MULTI-DVD:12" "You have selected iso file:
	 $ISOFILE

	Do you want to burn a multi-session CD or DVD?
	A multi-session CD/DVD is one that is left \"open\" so that further
	tracks may be burnt later. The iso file that you have selected
	will be burnt now as the first track.

	Note, this is an experimental option for the Puppy live-CD/DVD, to
	allow burning of sessions back to CD/DVD, thus personal data is saved
	to CD/DVD and a hard drive or usb stick is not required. If you choose
	MULTI-CD, you will be burning to a CD-R or CD-RW. The MULTI-DVD button
	is for burning the iso to a DVD-R. The latter is preferable.

	Please choose NORMAL unless you have some special reason to burn the
	CD/DVD multi-session (such as the iso is specifically for multisession).
	NOTE: currently there is no difference between NORMAL-DVD and MULTI-DVD,
		  that is, this script leaves the DVD open in both cases.

	Click MULTI-CD or MULTI-DVD for multi-session...
	Click NORMAL-CD or NORMAL-DVD button for normal burn..."
	case $? in
	 10) #normal cd
	  BURNMULTI=""
	  MEDIATYPE="CD"
	  BURNMSG=""
	  ;;
	 13) #normal dvd
	  BURNMULTI=""
	  MEDIATYPE="DVD"
	  BURNMSG="(blank DVD-R. A DVD-RW will be fast-wiped if it already has data)"
	  ;;
	 11) #multi cd
	  BURNMULTI="-multi"
	  MEDIATYPE="CD"
	  BURNMSG=""
	  ;;
	 12) #multi dvd
	  BURNMULTI="yes"
	  MEDIATYPE="DVD"
	  BURNMSG="(blank DVD-R. A DVD+/-RW will be fast-wiped if it has data)"
	  ;;
	 *)
	  exit
	  ;;
	esac

	#####BLANK IT
	if [ "$MEDIATYPE" = "CD" ];then
	 xmessage -bg "#ffc0c0" -center -name "burniso2cd" -title "Burniso2cd: Blank CD-rw?" -buttons "No Blank:10,Fast Blank:13,Full Blank:11" "You have decided to burn a cd.  If it is a cdrw, you will need to blank it.  Would you like to do so now?"
	 case $? in
	 10) #No Blank
	  BLANKIT=""
	  ;;
	 13) #Fast Blank
	  BLANKIT="-blank=fast"
	  ;;
	 11) #Full Blank
	  BLANKIT="-blank=all"
	  ;;
	 *)
	  exit
	  ;;
	 esac
	else
	 BLANKIT=""
	fi
	#####END BLANK IT

	while [ 1 ];do #burn-again-loop
	xmessage -bg "#ffc0c0" -center -name "burniso2cd" -title "Burniso2cd: Burn CD" -buttons "OKAY:10" "Please insert blank $MEDIATYPE into $CDR
	$BURNMSG
	(which is described as: ${CDDESCR})

	Then click OKAY button..."
	if [ ! $? -eq 10 ];then
	 exit
	fi

	if [ "$MEDIATYPE" = "CD" ];then
	 echo "Now executing:"
	 echo " cdrecord $BLANKIT $BURNMULTI -data -eject -v speed=4 dev=ATAPI:$CDR $ISOFILE"
	 sync
	 rxvt -name burniso2cd -bg orange -geometry 80x10 -e cdrecord $BLANKIT $BURNMULTI -data -eject -v speed=4 dev=ATAPI:$CDR "$ISOFILE"
	else #dvd
	 echo "Now executing:"
	 echo " growisofs -speed=4 -Z $CDR=$ISOFILE"
	 rxvt -name burniso2cd -bg orange -geometry 80x10 -e growisofs -speed=4 -Z $CDR="$ISOFILE"
	fi
	sync
	echo "...done"
	eject $CDR
	xmessage -bg "#80ff80" -center -name "burniso2cd" -title "Burniso2cd: Finished" -buttons "FINISHED:10,REPEAT:11" "If all went well, you have now burnt iso file
	$ISOFILE
	to a $MEDIATYPE!

	If you want to burn the iso file to another $MEDIATYPE,
	click REPEAT button...

	Otherwise, click FINISHED to quit..."
	[ $? -lt 11 ] && break
	done #burn-again-loop

	###END###
	echo "DONE."

	} #END BURNBABYBURN

cleanup() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Unmounting $HACKYROOT
	echo "unmounting $HACKYROOT..."
	rox -D "$HACKYROOT" > /dev/null 2>&1
	umount "$HACKYROOT"
	IsERROR=$?
	sleep 2   #give it time to unmount
	if [ $IsERROR = 0 ]; then
		if [ ! -e "$HACKYROOT/*" ] ;
		then
			rm "$HACKYROOT" -r
			Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "Environment unmounted" 6 40
		else
		Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "ERROR: Stuff in $HACKYROOT/\n\nEnvironment NOT unmounted" 9 40
		fi
	else
		Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "ERROR: Not unmounted properly\n\nEnvironment may not be unmounted" 9 40
	fi
	echo "DONE."

	} #END CLEANUP


deletefilesystem() {

	#Load important paths
	echo "loading important paths..."
	REMASTERPATH="`cat remasterpath`"
	ISOPATH="`cat isopath`"
	ISOFILE="$ISOPATH/../puppy.iso"

	#Verify
	Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --yesno "Are you absolutely positive you wish to PERMANANTLY remove $REMASTERPATH?  If you choose 'Yes,' $REMASTERPATH will be completely deleted, including $REMASTERPATH/puppy.iso if it exists.\nDELETE ANYWAY?" 11 60
	ANSWER=$?
	case $ANSWER in
			0)
				echo "deleting $REMASTERPATH..."
				rox -D "$REMASTERPATH" > /dev/null 2>&1
				rm "$REMASTERPATH" -R
				Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "$REMASTERPATH is no more.  My work here is done.  Adios amigo." 8 40 0
			;;
			*)
				echo "Deletion ABORTED"
				Xdialog --title "HackyRemaster" --wrap --stdout --no-cancel --msgbox "Deletion ABORTED\n(wuss)" 7 40 0
			;; esac
	echo "DONE."

	} #END DELETEFILESYSTEM
