#!/bin/sh



#Get the applocation (app + location, not a
#misspelling of application)
LOCATION="$0"
SCRIPTNAME=`basename "$LOCATION"`
SCRIPTLOCATION="${LOCATION%%/$SCRIPTNAME}"
cd "$SCRIPTLOCATION"
APPLOCATION=$PWD
echo "$APPLOCATION" > ./location

#Set the mount-points
HACKYROOT="/mnt/hackyroot"
HACKYIMAGE="/mnt/hackyimage"

#Load functions.sh
. ./functions.sh

#Check parameters
case $1 in
        --setupenviron)
				#Set everything up
				setupenviron
                exit 0
        ;;
        --readyenviron)
				#Mount hackyroot
				readyenviron
                exit 0
        ;;
        --hackypupbegone)
				#Run HackyPupBeGone
				hackypupbegone
                exit 0
        ;;
        --recompressusr)
				#Recompress usr_cram.fs
				recompressusr
                exit 0
        ;;
        --makerootimage)
				#Recompress the image.gz
				makerootimage
                exit 0
        ;;
        --editisolinuxcfg)
				#Edit isolinux.cfg
				editisolinuxcfg
                exit 0
        ;;
        --makeintoiso)
				#Make it into an iso
				makeintoiso
                exit 0
        ;;
        --burnbabyburn)
				#Burn that Puppy
				burnbabyburn
                exit 0
        ;;
        --cleanup)
				#Unmount hackyroot
				cleanup
                exit 0
        ;;
        --deletefilesystem)
				#Delete all work
				deletefilesystem
                exit 0
        ;;
        --controlpanel)
				#Run the control panel
				rxvt -e ./ControlPanel
                exit 0
        ;;
        --help|-h|--readme)
                rox README
                exit 0
        ;;
        --hackypupbegone-readme)
                rox README-hackypupbegone
                exit 0
        ;;
        *)
                echo "Error: no such option $1"
                rox README
                exit 1
        ;;esac
