#!/bin/sh

# installs HackyRemaster in my-roxapps

tar -xz --no-same-owner -f dotpup.tar.gz
if [ -e $HOME/my-roxapps/HackyRemaster ]; then
	#Preserve any location files if they exist
	if [ -e $HOME/my-roxapps/HackyRemaster/remasterpath ]; then
		cp $HOME/my-roxapps/HackyRemaster/remasterpath /tmp/remasterpath
		cp $HOME/my-roxapps/HackyRemaster/isopath /tmp/isopath
	fi
	#Prompt to backup or overwrite
	Xdialog --title "HackyRemaster Installation" --wrap --stdout --no-cancel --yesno "Do you wish to back up your old HackyRemaster?  If you choose 'Yes' it will be renamed HackyRemaster_BAK.  If you choose 'No' it will be overwritten." 8 60
	BACKUP=$?
	if [ $BACKUP = 0 ]; then
		mv $HOME/my-roxapps/HackyRemaster $HOME/my-roxapps/HackyRemaster_BAK;
	else
		rm -R $HOME/my-roxapps/HackyRemaster
	fi
fi
mv HackyRemaster $HOME/my-roxapps/HackyRemaster

#Return any preserved location files
if [ -e /tmp/remasterpath ]; then
	cp /tmp/remasterpath $HOME/my-roxapps/HackyRemaster/remasterpath
	cp /tmp/isopath $HOME/my-roxapps/HackyRemaster/isopath
fi

#Add xdg menu entry
mv hackyremaster.desktop /usr/share/applications/hackyremaster.desktop


# opens the my-roxapps folder and also shows README
# rox will use whatever run action is configured for README
exec rox $HOME/my-roxapps/ $HOME/my-roxapps/HackyRemaster/README
